<?php
/**
 * @package   AkeebaLoginGuard
 * @copyright Copyright (c)2016-2022 Nicholas K. Dionysopoulos / Akeeba Ltd
 * @license   GNU General Public License version 3, or later
 */

namespace Akeeba\Component\LoginGuard\Administrator\Event;

defined('_JEXEC') or die;

use Joomla\CMS\Event\AbstractImmutableEvent;

/**
 * Concrete event class for the custom events used to notify our User Action Log plugin
 *
 * @package     Akeeba\Component\LoginGuard\Administrator\Event
 *
 * @since       6.0.0
 */
class NotifyActionLog extends AbstractImmutableEvent
{
	private const ACCEPTABLE_EVENTS = [
		'onComLoginguardCaptiveValidateSuccess',
		'onComLoginGuardViewMethodsAfterDisplay',
		'onComLoginguardCaptiveShowCaptive',
		'onComLoginguardCaptiveShowSelect',
		'onComLoginguardCaptiveValidateFailed',
		'onComLoginguardCaptiveValidateInvalidMethod',
		'onComLoginguardCaptiveValidateSuccess',
		'onComLoginguardControllerMethodAfterRegenbackupcodes',
		'onComLoginguardControllerMethodBeforeAdd',
		'onComLoginguardControllerMethodBeforeDelete',
		'onComLoginguardControllerMethodBeforeEdit',
		'onComLoginguardControllerMethodBeforeSave',
		'onComLoginguardControllerMethodsBeforeDisable',
		'onComLoginguardControllerMethodsBeforeDontshowthisagain',
		'onComLoginguardControllerConvertAfterConvert',
	];

	public function __construct(string $name, array $arguments = [])
	{
		if (!in_array($name, self::ACCEPTABLE_EVENTS))
		{
			throw new \InvalidArgumentException(sprintf('The %s event class does not support the %s event name.', __CLASS__, $name));
		}

		parent::__construct($name, $arguments);
	}
}